#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <fcntl.h>

#define BALKSIZE (188 * 100)
#define MAXBUFSIZE (BALKSIZE)

int main(int argc, char *argv[])
{
  unsigned char *buf = NULL;
  int buflen = 0;
  int enable = 0;
  int ch = 0;
  long long int bytes = 0;
  long long int offset = 0;

  buf = (unsigned char *)malloc(MAXBUFSIZE);
  if (buf == NULL) return 1;

  while ((ch = getchar()) != EOF) {
    bytes++;

    if (enable == 0) {
      /* search */
      if (ch == 0x47) {
	fprintf(stderr, "first found(%lld bytes)\n", bytes);
	enable = 1;
	offset = bytes;
      }
    } else if (enable == 1) {
      /* sync */
      if (ch == 0x47) {
	if (bytes == (offset + 188)) {
	  fprintf(stderr, "sync found.\n");
	  enable = 2;
	} else {
	  fprintf(stderr, "sync error.\n");
	  enable = 0;
	}
      }
    }

    if (enable == 2) {
      /* output */
      if (ch != 0x47) {
	fprintf(stderr, "not found sync(%lld bytes).\n", bytes);
	enable = 0;
      } else {
	int rlen = 0;

	rlen = fread(buf, 1, BALKSIZE - 1, stdin);
	bytes += rlen;

	if (rlen != (BALKSIZE - 1)) {
	  fprintf(stderr, "not data(%lld bytes).\n", bytes);
	  enable = 0;
	} else {
	  int wlen = 0;

	  fputc(ch, stdout);
	  wlen = fwrite(buf, 1, BALKSIZE - 1, stdout);
	  if (wlen != rlen) {
	    fprintf(stderr, "data write error(%lld bytes).\n", bytes);
	    break;
	  }
	}
      }
    }
  }
  return 0;
}
